import type { Component, InjectionKey, ShallowUnwrapRef } from 'vue';
export declare type IDialogItemId = number | string;
export declare type DialogOnCloseEvent = {
    id: IDialogItemId;
    item: IDialogItem;
    cancel: () => void;
};
export interface IDialogItem {
    component: ShallowUnwrapRef<Component>;
    id: IDialogItemId;
    props: {
        modelValue: boolean;
    };
    onClose?: ((event: DialogOnCloseEvent) => void) | undefined;
}
declare type DialogAddMethod = <T>(params: {
    component: Component;
    props?: Omit<T, 'modelValue'> | undefined;
    id?: IDialogItemId | undefined;
}, hooks?: {
    onClose?: ((event: DialogOnCloseEvent) => void) | undefined;
}) => IDialogItemId;
declare type DialogRemoveMethod = (id: IDialogItemId, closeDelay?: number) => void;
interface IDialogMethods {
    addDialog: DialogAddMethod;
    removeDialog: DialogRemoveMethod;
}
export interface IDialog extends IDialogMethods {
    dialogs: IDialogItem[];
}
export declare type DialogInjectionKey = InjectionKey<IDialog>;
export {};
//# sourceMappingURL=Plugin.d.ts.map